% RWTH Aachen Latex Theme for beamer presentations
%
% http://xtemplate.net/rwth.html
% (c) 2012-2014 by Tobias Pohlen <tobias.pohlen@gmail.com>
% Released under the GPL License.
%
% Version 0.4

\mode<presentation>
\usepackage{pgfcomp-version-0-65}
\usepackage{color}
\usepackage[absolute,overlay]{textpos}
\usepackage[no-math]{fontspec}
\usepackage[utf8]{inputenc}
\usepackage[english]{babel}

% Restyle the left margins for the itemize lists
\setlength{\leftmargini}{5mm}

\newlength{\rwth@footerpos}
\newlength{\rwth@footertextpos}
\newlength{\rwth@footerwidth}
\newlength{\rwth@headerwidth}

% Define some colors. The colors defined in the  manual
    \definecolor{RWTHblue}{RGB}{0,83,159}
    \definecolor{RWTHblack}{RGB}{0,0,0}
    \definecolor{RWTHwhite}{RGB}{255,255,255}
    \definecolor{RWTHlightblue}{RGB}{142,186,226}
    \definecolor{RWTHgrey}{RGB}{51,51,51}
    \definecolor{RWTHlightgrey}{RGB}{204,204,204}
    \definecolor{RWTHsuperlightgrey}{RGB}{247,247,247}
    \definecolor{RWTHpetrol}{RGB}{0,97,101}
    \definecolor{RWTHteal}{RGB}{0,152,161}
    \definecolor{RWTHmaygreen}{RGB}{189,205,0}
    \definecolor{RWTHgreen}{RGB}{87,171,39}
    \definecolor{RWTHyellow}{RGB}{255,237,0}
    \definecolor{RWTHorange}{RGB}{246,168,0}
    \definecolor{RWTHmagenta}{RGB}{227,0,102}
    \definecolor{RWTHred}{RGB}{204,7,30}
    \definecolor{RWTHbordeaux}{RGB}{161,16,53}
    \definecolor{RWTHviolet}{RGB}{97,33,88}
    \definecolor{RWTHpurple}{RGB}{122,111,172}

% Assign the colors to the differen pars
    % Title
    \setbeamercolor{title}{fg = RWTHblue}
    % Frame title
    \setbeamercolor{frametitle}{fg = RWTHblue}
    % Table of contents
    \setbeamercolor{section in toc}{fg = RWTHblack}
    \setbeamercolor{subsection in toc}{fg = RWTHblue}
    \setbeamercolor{section in toc shaded}{fg = RWTHblack}
    % List colors (itemize)
    \setbeamercolor{item}{fg = RWTHblack}
    \setbeamercolor{subitem}{fg = RWTHblack}
    \setbeamercolor{subsubitem}{fg = RWTHblack}
    % The color of the bullets points
    \setbeamercolor{description item}{fg = RWTHblue}
    % Captions
    \setbeamercolor{caption}{fg = RWTHblack}
    \setbeamercolor{caption name}{fg = RWTHblack}

    % Style the block elements:
    % - Standard blocks
    % - Alert blocks
    % - Example block
        % Standard block
        \setbeamercolor{block title}{fg = RWTHblue, bg = RWTHlightgrey}
        \setbeamercolor{block body}{fg = RWTHblack, bg = RWTHsuperlightgrey}
    
        % Alert block
        \setbeamercolor{block title alerted}{fg = RWTHwhite, bg = RWTHgrey}
        \setbeamercolor{block body alerted}{fg = RWTHblack, bg = RWTHsuperlightgrey}
        
        % Example block
        \setbeamercolor{block title example}{fg = RWTHwhite, bg = RWTHblue}
        \setbeamercolor{block body example}{fg = RWTHblack, bg = RWTHsuperlightgrey}
    
    % Normal text
    \setbeamercolor{normal text}{fg = RWTHblack}

% Define the fonts
    % Here we are using default fonts
    \usefonttheme{default}
    % Math elements ought to be rendered in serif-font
    \usefonttheme[onlymath]{serif}
    
    % Fontsize for the presentation title
    \setbeamerfont{title}{size = \huge}
    
    % Fontsize of the frame titles
    \setbeamerfont{frametitle}{size = \Large}

\setbeamersize{text margin left=5mm,text margin right=5mm}

% Set the list-style-type of an itemized list to triangles. 
\setbeamertemplate{itemize items}[square]

% Remove the circles in an enumerated itemized list
\setbeamertemplate{enumerate items}[default]

\setbeamertemplate{blocks}[default]


% Remove the navigation symbols since I don't think they are useful at all
\setbeamertemplate{navigation symbols}{}

% This command creates the website like headline with the RWTH logo.
% 
% @param1 The content of the black header bar
% @param2 The content of the light grey bar next to the logo
\newcommand{\RWTHheader}[2]
{
    % I'm using absolute positioning here since it's a lot easier 
    % At the end I use a vspace to emulate the height of the header bar

    % The black box at the top
    \begin{textblock*}{\paperwidth}(0pt,2mm)
        \begin{pgfpicture}{0}{0}{0}{0}
            \pgfsetlinewidth{4mm}
            \color{RWTHblack}
            \pgfline{\pgfpoint{0mm}{0mm}}{\pgfpoint{\paperwidth}{0}}
        \end{pgfpicture}
    \end{textblock*}
    % The text in the black box
    \begin{textblock*}{\paperwidth}(5mm, 1.3mm)
        \textbf{\tiny{\textcolor{RWTHlightgrey}{\RWTHremovelinebreaks{#1}}}}
    \end{textblock*}
    % The light grey box
    \begin{textblock*}{\paperwidth}(0mm,8mm)
        \begin{pgfpicture}{0}{0}{0}{0}
            \pgfsetlinewidth{8mm}
            \color{RWTHsuperlightgrey}
            \pgfline{\pgfpoint{0mm}{0mm}}{\pgfpoint{\paperwidth}{0}}
        \end{pgfpicture}
    \end{textblock*}
    % The text in the light grey box
	\setlength{\rwth@headerwidth}{\dimexpr(\paperwidth-10mm)}
    \begin{textblock*}{\rwth@headerwidth}(5mm, 6.5mm)
        #2
    \end{textblock*}
    % The space to emulate the height of the object
    \vspace*{10mm}
}

% This command is used to remove the linebreaks from the title to display the title in the header bar
%
% @param1 The string whose linebreaks shall be removed
\newcommand{\RWTHremovelinebreaks}[1]
{
    \begingroup\def\\{ }#1\endgroup
}

% This command creates the title page
\newcommand{\RWTHtitle}
{
    \begin{frame}[plain]
        \titlepage
    \end{frame}
}

% Style the frame title
\setbeamertemplate{frametitle}{
    % Print "-" only if subsection is given.
   \ifx\insertsubsection\empty
        \RWTHheader{\insertsection}{\insertframetitle}
    \else
        \RWTHheader{\insertsection \ \textbullet \ \insertsubsection}{\insertframetitle}
    \fi
}

% Style the frame footer
\setbeamertemplate{footline}{
	\setlength{\rwth@footerpos}{\dimexpr(\paperheight-2mm)}
	\setlength{\rwth@footertextpos}{\dimexpr(\paperheight-2.75mm)}
	\setlength{\rwth@footerwidth}{\dimexpr(\paperwidth-10mm)}
	% Box
	\begin{textblock*}{\paperwidth}(0pt,\rwth@footerpos)
		\begin{pgfpicture}{0}{0}{0}{0}
			\pgfsetlinewidth{4mm}
			\color{RWTHgrey}
			\pgfline{\pgfpoint{0mm}{0mm}}{\pgfpoint{\paperwidth}{0}}
		\end{pgfpicture}
	\end{textblock*}
	% Text
	\begin{textblock*}{\paperwidth}(5mm,\rwth@footertextpos)
		\makebox[\rwth@footerwidth]{\textbf{\tiny{\textcolor{RWTHlightgrey}{\inserttitle \ \ | \ \insertauthor \ \ | \ \insertdate \hfill \insertframenumber/\inserttotalframenumber}}}}
	\end{textblock*}
}

% Style the title page
\setbeamertemplate{title page}{
	
	\begin{textblock*}{6cm}(9.75cm,0.25cm)
        \includegraphics[width=\linewidth]{content-slides/pictures/logo_ths.png}
    \end{textblock*}
	
	\bigskip\bigskip\bigskip\bigskip

	\begin{center}
		% The presentation title
		\LARGE Cylindrical Algebraic Decomposition \\ for Nonlinear Arithmetic Problems
		
		\bigskip
		
		% The authors
		\textcolor{RWTHgrey}{\large \insertauthor}
		
		% The current date
		\textcolor{RWTHgrey}{\normalsize PhD defense talk \\ \insertdate}

		\bigskip
		
		\parbox{0.9\linewidth}{\scriptsize
			Grateful for the cooperation with and advise from:
			
			Erika Ábrahám, Jens Brandt, Christopher Brown, Florian Corzilius, James H. Davenport, Matthew England,
			Vijay Ganesh, Rebecca Haehn, Marcel Hark, Einar~Broch~Johnsen, Sebastian Junges, Viktor Levandovskyy,
			Jacopo Mauro, Jasper Nalbach, Stefan Schupp, Tarik Viehmann, and many more.
		}
	\end{center}

	% Don't remove this line break ^
}